#!/bin/bash
# --- T2-COPYRIGHT-NOTE-BEGIN ---
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
# 
# T2 SDE: target/mnemosyne/tools/test_pkgsel.sh
# Copyright (C) 2004 - 2005 The T2 SDE Project
# 
# More information can be found in the files COPYING and README.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License. A copy of the
# GNU General Public License can be found in the file COPYING.
# --- T2-COPYRIGHT-NOTE-END ---

source ./scripts/functions

config=default
if [ "$1" == "-cfg" ]; then
	config="$2"; shift
	shift
fi

if [ ! -f config/$config/packages ]; then
	echo "usage: $0 [-cfg <config>]"
	exit 1
fi

function test_pkgselfile() {
	local file="$1"
	local count=
	local buffer=
	
	while read -r rule ; do
		[ -z "$rule" -o "${rule:0:1}" == "#" ] && continue
		line="$( ( echo "$rule" | pkgsel_parse ) \
			| sed -e 's,$1=\".\",print \$5,')"

		buffer=$( gawk "`pkgsel_init`$line" < config/$config/packages | tr '\n' ' ' )
		count=$( echo "$buffer" | wc -w )

		echo -n " rule: $rule "
		if [ $count -gt 0 ]; then
			echo "($buffer)"
		else	
			echo "no matches!"
		fi
	done < $file
}

function test_pkgsel() {
	local location="$1"
	local name="${1##*/}"
	local prefix="$2"

	echo "pkgsel: $prefix$name"
	for x in $location/*; do
		if [ -d "$x" ]; then
			test_pkgsel "$x" "$prefix$name"
		else
			echo "ruleset: ${x##*/}" 1>&2
			test_pkgselfile "$x"
		fi
	done
}

for x in ./target/mnemosyne/pkgsel/*; do
	test_pkgsel "$x" ""
done
